/* 
 * Copyright (c) 2004 LAAS/CNRS                       --  Wed Dec  15 2004
 * All rights reserved.                                    
 *
 * $Id: libimu.h,v 1.2 2007/06/29 15:13:30 tpeynot Exp $
 */
#ifndef H_LIBIMU
#define H_LIBIMU

#define IMU_OK	0
#define IMU_ErrNum(mod,num) ((((mod) & 0xFFFF) << 16) | ((num) & 0xFFFF))

#define Cf_ImuId  1025

#define ERR_IMU_OFFLIMITS                   IMU_ErrNum(Cf_ImuId,1)

#define ERR_IMU_MALLOC                      IMU_ErrNum(Cf_ImuId,2)
#define ERR_IMU_BADPARAMS                   IMU_ErrNum(Cf_ImuId,3)

/****** Macros *******************************************/
#ifndef SQ
#define SQ(a)	((a)*(a))
#endif

#ifndef MAX
#define MAX(a,b)	((a)<(b)?(b):(a))
#endif

/*-------- Exported Functions ------------------------------*/


int
imuGravityEstimation(double  gravity[3],   /* OUTPUT: the estimated gravity vector */
		     /* Must be initialized !! */
		     double  Bestimated[3],   /* OUTPUT: the 3 gyros estimated biases */
		     /* Must be initialized !! */
		     double  mes_gyro[3],  /* the 3 omega measured by the IMU gyros */
		     double  mes_accel[3],  /* the 3 accel measured by the IMU acceleros */
		     double  Km,     /* Explications ? */
		     double  Kb,     /* Explications ? */
		     double  timePerSample );  /* Sampling Period */


int
imuAttitudeAngles(double  angles[2],   /* output: the attitude angles */
		  double  gravityVect[3] );  /* Estimation of the gravity Vector */

int
imuComputeEnergyInit(int  nbCycles);

int
imuComputeEnergy(float*  pitchRateEnergy, 
		 float*  rollRateEnergy,
		 float   pitchRate, 
		 float   rollRate, 
		 int     timeWidth_nbCycles);

float 
imu_sigmoid (float    x,
	     float    m, 
	     float    sigma );



#endif /* H_LIBLLOCO */
